class TelegramNotifyUpcomingJob < ApplicationJob
  queue_as :default

  def perform(args)
    offset = args["offset"]
    interval = args["interval"]
    Session.scheduled.includes(:stage, :assignments).where(stage: RelevantStage.joins(:stage).map(&:stage)).where(starts_at: (Time.now + offset)..(Time.now + offset + interval)).order(:starts_at).each do |session|
      puts session.inspect
      assignees = session.assignments.map(&:user)
      if assignees.length.positive?
        notify_names = assignees.map { |a| a.telegram_username ? "@#{a.telegram_username}" : a.name }

        message = notify_names.join(' ') + ": Your scheduled session <i>#{session.title}</i> starts at <b>#{session.starts_at.strftime("%H:%M")}</b> on <b>#{session.stage.name}</b>"
        TelegramGroupChatNotificationJob.perform_later(target: "-316096320", text: message, parse_mode: 'HTML')
        # TelegramGroupChatNotificationJob.perform_now(target: "2192297", text: message, parse_mode: 'HTML')
      else
        message = "<b>⚠️ No assignees</b> for session <i>#{session.title}</i> starting at <b>#{session.starts_at.strftime("%H:%M")}</b> on <b>#{session.stage.name}</b>"
        TelegramGroupChatNotificationJob.perform_later(target: "-316096320", text: message, parse_mode: 'HTML')
        # TelegramGroupChatNotificationJob.perform_now(target: "2192297", text: message, parse_mode: 'HTML')
      end
    end
  end
end
